﻿Imports System
Imports System.Data
Imports System.Data.OleDb
Imports System.Threading.Tasks
Imports System.Windows.Forms

Namespace FlexReportSample
    Public Partial Class Form1
        Inherits Form
        Private _reportSource As DataSet = New DataSet()

        Public Sub New()
            InitializeComponent()
        End Sub

        Private Sub Form1_Load(sender As Object, e As EventArgs)
            ' load data once at the start of application
            ' after that, use DataTable to assign Data to FlexReport 

            LoadData()
        End Sub

        ''' <summary>
        ''' loads data from SQL into DataSet
        ''' </summary>
        Private Async Sub LoadData()
            Dim conn = "provider=microsoft.jet.oledb.4.0;data source=..\\..\\sample.mdb;"

            ' set up SQL statement
            Dim rs = "Select * from [Customers]"

            ' retrieve data into DataSet
            Dim da = New OleDbDataAdapter(rs, conn)
            da.Fill(_reportSource, "Customers")

            _reportSource.Tables(0).Columns.Add("Value1", GetType(String))
            _reportSource.Tables(0).Columns.Add("Value2", GetType(String))
            For i = 0 To _reportSource.Tables(0).Rows.Count - 1
                _reportSource.Tables(0).Rows(i)("Value1") = _reportSource.Tables(0).Rows(i)("Address").ToString().Split(" "c)(0)
                _reportSource.Tables(0).Rows(i)("Value2") = _reportSource.Tables(0).Rows(i)("Address").ToString().Split(" "c)(1)
            Next

            Await Task.Delay(500)
            c1FlexReport1.Load("..\..\SampleReport.flxr", "CustomersReport")

            'applying datatable
            c1FlexReport1.DataSource.Recordset = _reportSource.Tables("Customers")

            'rendering the report
            c1FlexReport1.Render()
            c1FlexViewer1.DocumentSource = c1FlexReport1

        End Sub

        Private Sub customersToolStripMenuItem_Click(sender As Object, e As EventArgs)

        End Sub

        Private Sub categoriesToolStripMenuItem_Click(sender As Object, e As EventArgs)
            'loading report
            c1FlexReport1.Load("..\..\SampleReport.flxr", "CategoriesReport")

            'applying datatable
            c1FlexReport1.DataSource.Recordset = _reportSource.Tables("Categories")

            'rendering the report
            c1FlexReport1.Render()
        End Sub
    End Class
End Namespace
